<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden.  www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 3.10 - 4.11.2023
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2023
 * @version 	3.10 (PHP8.2)
 * -----------------------------------------
 */
include_once("../inc/functions.php");
$url = getUrl();
if (@file_exists('../inc/config.php')){
    if (@file_exists('../install/index.php')) {
        echo 'Bitte l&ouml;schen Sie das Verzeichnis "install" auf den Server.';
        exit;
    } else {
        include_once("../inc/config.php");
    }

}
else {
    header("Location:" . $url . "/install/");
}
include_once("../class/dbcache_class.php");
include_once("../class/parse.php");
include_once("../class/upload_class.php");
$dbh = new DBI($db_host, $db_datenbank, $db_user, $db_passwort, $root_dir . '/cache/');
include_once("session.php");
$url = 'http' . (($_SERVER['HTTPS'] === 'on') ? 's' : '') . '://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
$tpl = new parse();
$tpl->set_tpl_pfad($root_dir . "/tpl/admin/");
$tpl->set_file("kategorie_anlegen.html");
$tpl->set_script_version($script_version);
if (!isset($_POST['senden'])) $_POST['senden'] = '';
if (!isset($_POST['kategorie_name'])) $_POST['kategorie_name'] = '';
if (!isset($_POST['kategorie_beschreibung'])) $_POST['kategorie_beschreibung'] = '';
if (!isset($_POST['verzeichnis'])) $_POST['verzeichnis'] = '';
$meldung = '';
$medlung_fehler = '';
$fehler = '';
if (!empty($_POST['senden']) and !empty($_POST['kategorie_name']) and !empty($_POST['kategorie_beschreibung']) and !empty($_POST['verzeichnis'])) {
    $dir = new image_upload();
    if ($_POST['verzeichnis'] != '') $dir->setnewdir($_POST['verzeichnis']);
    else $dir->setnewdir($_POST['kategorie_name']);
    $dir->setpfad($root_dir);
    if ($dir->create_dir()) {
        if ($_POST['verzeichnis'] != '') $kategorie_dir = image_upload::key_url($_POST['verzeichnis']);
        else $kategorie_dir = image_upload::key_url($_POST['kategorie_name']);

        $sql_insert = "INSERT INTO `kategorie` (`kategorie_dir`,`kategorie_name`,`kategorie_beschreibung`) VALUES(
					'" . $dbh->escape($kategorie_dir) . "', '" . $dbh->escape($_POST['kategorie_name']) . "', '" . $dbh->escape($_POST['kategorie_beschreibung']) . "');";
        $sth = $dbh->prepare($sql_insert);
        $sth->execute();
        $meldung = 'Kategorie wurde gespeichert.';
    } else {
        $medlung_fehler = 'Ein Ordner f&uuml;r die Kategorie konnte nicht angelegt werden.';
    }
} else {
    if ($_POST['senden'] != '') {
        if ($_POST['kategorie_name'] == '' and $medlung_fehler == '') {
            $medlung_fehler = 'Bitte geben Sie ein Kategoriename ein!';
        }
        if ($_POST['kategorie_beschreibung'] == '' and $medlung_fehler == '') {
            $medlung_fehler = 'Bitte geben Sie ein Beschreibung ein!';
        }
        if ($_POST['verzeichnis'] == '' and $medlung_fehler == '') {
            $medlung_fehler = 'Bitte geben Sie ein Verzeichnis f&uuml;r die Kategorie ein!';
        }
    }
}
$text["ueberschrift"] = 'Kategorie anlegen';
$text["meldung"] = $meldung;
$text["meldung_fehler"] = $medlung_fehler;
$text["text_kategorie_anlegen_admin"] = '<form action="kategorie_anlegen.php?' . SID . '" method="post">';
$text["text_kategorie_anlegen_admin"] .= '<table class="ps" cellpadding="0" cellspacing="0">';
$text["text_kategorie_anlegen_admin"] .= '	<tr>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top" class="psh">Kategoriename:</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td>&nbsp;</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top"><input type="text" size="40" value="' . htmlspecialchars($_POST['kategorie_name']) . '" name="kategorie_name" maxlength="255" /></td>';
$text["text_kategorie_anlegen_admin"] .= '	</tr>';
$text["text_kategorie_anlegen_admin"] .= '	<tr>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top" class="psht">Beschreibung:</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td>&nbsp;</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top"><textarea name="kategorie_beschreibung" cols="40" rows="5" >' . htmlspecialchars($_POST['kategorie_beschreibung']) . '</textarea></td>';
$text["text_kategorie_anlegen_admin"] .= '	</tr>';
$text["text_kategorie_anlegen_admin"] .= '	<tr>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top" class="psh">Kategorie-Verzeichnis:</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td>&nbsp;</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top"><input type="text" size="40" value="' . htmlspecialchars($_POST['verzeichnis']) . '" name="verzeichnis" maxlength="255" /></td>';
$text["text_kategorie_anlegen_admin"] .= '	</tr>';
$text["text_kategorie_anlegen_admin"] .= '	<tr>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top" class="psh">&nbsp;</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td>&nbsp;</td>';
$text["text_kategorie_anlegen_admin"] .= '		<td align="left" valign="top"><input type="submit" name="senden" value="Speichern" /></td>';
$text["text_kategorie_anlegen_admin"] .= '	</tr>';
$text["text_kategorie_anlegen_admin"] .= '</table>';
$text["text_kategorie_anlegen_admin"] .= '</form>';

$tpl->template($text);
$tpl->template_ausgabe();
?>