<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden.  www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 3.10 - 4.11.2023
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2023
 * @version 	3.10 (PHP8.2)
 * -----------------------------------------
 */
include_once("../inc/functions.php");
$url = getUrl();
if (@file_exists('../inc/config.php')){
    if (@file_exists('../install/index.php')) {
        echo 'Bitte l&ouml;schen Sie das Verzeichnis "install" auf den Server.';
        exit;
    } else {
        include_once("../inc/config.php");
    }

}
else {
    header("Location:" . $url . "/install/");
}
include_once("../class/upload_class.php");
include_once("../class/dbcache_class.php");
include_once("../class/parse.php");
$dbh = new DBI($db_host, $db_datenbank, $db_user, $db_passwort, $root_dir . '/cache/');
include_once("session.php");
$url = 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);

$tpl = new parse();
$tpl->set_tpl_pfad($root_dir . "/tpl/admin/");
$tpl->set_file("kategorie_verwalten.html");
$tpl->set_script_version($script_version);

if (!isset($_GET['delete'])) $_GET['delete'] = '0'; else $_GET['delete'] = sprintf("%d", $_GET['delete']);
if ($_GET['delete'] != '0') {

    $sql_select = "SELECT `kategorie_dir` FROM `kategorie` WHERE `id` = '" . $dbh->escape($_GET['delete']) . "' LIMIT 1;";
    $sth = $dbh->prepare($sql_select, '-1');
    $sth->execute();
    $daten = $sth->fetchrow_hash();
    $sth->finish();
    $dir = new image_upload();
    $dir->setrmdir_dir($root_dir . '/bilder/' . $daten['kategorie_dir']);
    if ($dir->rmdir_dir() == true) {
        $sql_delete = "DELETE FROM `kategorie` WHERE `id` = '" . $dbh->escape($_GET['delete']) . "' LIMIT 1;";
        $sth = $dbh->prepare($sql_delete);
        $sth->execute();
    } else {
        $medlung_fehler = 'Fehler: Die Kategorie konnte nicht gel&ouml;scht werden.
   					Bitte pr&uuml;fen Sie, ob in den Ordner noch Bilder vorhanden sind.';
    }
}

$sql_select = "SELECT id, kategorie_name, kategorie_dir FROM `kategorie` ORDER BY `kategorie_name` ASC ;";
$sth = $dbh->prepare($sql_select, '-1');
$sth->execute();
if (!isset($meldung)) $meldung = '';
if (!isset($medlung_fehler)) $medlung_fehler = '';

$text["ueberschrift"] = 'Kategorie verwalten';
$text["meldung"] = $meldung;
$text["meldung_fehler"] = $medlung_fehler;

$text["text_kategorie_verwalten_admin"] = '<table border="0" bordercolor="Gray" bgcolor="DarkGray" cellspacing="2" cellpadding="2" width="100%">' . "\n";
$text["text_kategorie_verwalten_admin"] .= '	<tr bgcolor="Gainsboro" style="font-weight:bold">' . "\n";
$text["text_kategorie_verwalten_admin"] .= '		<td class="fett">Kategoriename</td>' . "\n";
$text["text_kategorie_verwalten_admin"] .= '		<td class="fett">Verzeichnis</td>' . "\n";
$text["text_kategorie_verwalten_admin"] .= '		<td colspan="2" class="fett">Aktionen</td>' . "\n";
$text["text_kategorie_verwalten_admin"] .= '	</tr>' . "\n";
$i = 0;
while ($daten = $sth->fetchrow_hash()) {
    $text["text_kategorie_verwalten_admin"] .= '<tr bgcolor="Gainsboro">' . "\n";
    $text["text_kategorie_verwalten_admin"] .= '	<td class="view_dir_td_315">' . htmlspecialchars($daten['kategorie_name']) . '</td>' . "\n";
    $text["text_kategorie_verwalten_admin"] .= '	<td class="view_dir_td_90">/' . htmlspecialchars($daten['kategorie_dir']) . '</td>' . "\n";
    $text["text_kategorie_verwalten_admin"] .= '	<td class="view_dir_td_70"><a href="kategorie_bearbeiten.php?' . SID . '&id=' . $daten['id'] . '">Bearbeiten</a></td>' . "\n";

    $text["text_kategorie_verwalten_admin"] .= '	<td class="view_dir_td_70"><a href="javascript:frage_to_url(\'M&ouml;chten Sie diese Kategorie wirklich l&ouml;schen?\',
		 		\'kategorie_verwalten.php?' . SID . '&delete=' . $daten['id'] . '\');">L&ouml;schen</a></td>' . "\n";
    $text["text_kategorie_verwalten_admin"] .= '</tr>' . "\n";
    $i++;
}
if ($i == 0) {
    $text["text_kategorie_verwalten_admin"] .= '<tr bgcolor="Gainsboro">' . "\n";
    $text["text_kategorie_verwalten_admin"] .= '	<td colspan="4">Keine Datei vorhanden!</td>' . "\n";
    $text["text_kategorie_verwalten_admin"] .= '</tr>' . "\n";
}
$text["text_kategorie_verwalten_admin"] .= '</table>' . "\n";
$sth->finish();
$tpl->template($text);
$tpl->template_ausgabe();
?>