<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden.  www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 3.10 - 4.11.2023
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2023
 * @version 	3.10 (PHP8.2)
 * -----------------------------------------
 */
include_once("../inc/functions.php");
$url = getUrl();
if (@file_exists('../inc/config.php')){
    if (@file_exists('../install/index.php')) {
        echo 'Bitte l&ouml;schen Sie das Verzeichnis "install" auf den Server.';
        exit;
    } else {
        include_once("../inc/config.php");
    }

}
else {
    header("Location:" . $url . "/install/");
}
include_once("../class/dbcache_class.php");
include_once("../class/parse.php");
include_once("../class/upload_class.php");
include_once("../class/directory_list_class.php");

$dbh = new DBI($db_host, $db_datenbank, $db_user, $db_passwort, $root_dir . '/cache/');
include_once("session.php");
$url = 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
if (!isset($_POST['send_file'])) $_POST['send_file'] = '';
if (!isset($_POST['ajax'])) $_POST['ajax'] = '';
if (!isset($_POST['beschreibung'])) $_POST['beschreibung'] = '';
if (!isset($_POST['kategorie']) and isset($_GET['kategorie']))
    $_POST['kategorie'] = sprintf("%d", $_GET['kategorie']);
if (!isset($_POST['kategorie'])) $_POST['kategorie'] = '0'; else $_POST['kategorie'] = sprintf("%d", $_POST['kategorie']);
if (!isset($_FILES['this_file'])) $_FILES['this_file'] = '';
$meldung = '';
$medlung_fehler = '';
$sql_select = "SELECT * FROM `einstellung` ;";
$sth = $dbh->prepare($sql_select, '-1');
$sth->execute();
$bilder_anz = 0;
while ($daten = $sth->fetchrow_hash()) {
    $einstellung[$daten['name']] = $daten['wert'];
}
$sth->finish();
$beschreibung = '';
if ($_POST['ajax'] == 1) {
    $gd_info = gd_info();
    $gd_support = array();
    if (!isset($gd_info['GIF Create Support'])) $gd_info['GIF Create Support'] = '';
    if (!isset($gd_info['JPG Support'])) $gd_info['JPG Support'] = '';
    if (!isset($gd_info['JPEG Support'])) $gd_info['JPEG Support'] = '';
    if (!isset($gd_info['PNG Support'])) $gd_info['PNG Support'] = '';

    $sql_select = "SELECT kategorie_dir FROM `kategorie` WHERE `id`='" . $dbh->escape($_POST['kategorie']) . "' LIMIT 1;";
    $sth = $dbh->prepare($sql_select, '-1');
    $sth->execute();
    $daten = $sth->fetchrow_hash();
    $array = array();
    $array['result'] = array();
    $bilder = array();
    $upload = new image_upload();
    if ($gd_info['GIF Create Support'] == true) {
        $i = 0;
        foreach (glob($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . "*.[Gg][Ii][Ff]") as $filename) {
            $filename_orginal = basename($filename);
            if ($einstellung['beschreibung_automatisch'] == '1')
                $beschreibung = $upload->get_beschreibung($filename);
            $filename = image_upload::key_url(basename($filename));
            rename($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . $filename_orginal, $root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . $filename);
            $sql_select = "SELECT id FROM `bilder` WHERE dateiname = '" . $dbh->escape(basename($filename)) . "' " . (($_POST['kategorie'] != '') ? "AND `kategorie_id`='" . $dbh->escape($_POST['kategorie']) . "'" : "") . " LIMIT 1;";
            $sth = $dbh->prepare($sql_select, '-1');
            $sth->execute();
            if ($sth->rows() == '0') {
                $sql_insert = "INSERT INTO `bilder` (`id`,`dateiname`,`kategorie_id`,`timestamp`,`admin_id`, `beschreibung`) VALUES(
				    		'','" . $dbh->escape(basename($filename)) . "'," . (($_POST['kategorie'] != '') ? "'" . $dbh->escape($_POST['kategorie']) . "'" : "'0'") . ",'" . time() . "','" . $zeileholen['id'] . "', '" . $dbh->escape($beschreibung) . "');";
                $sth = $dbh->prepare($sql_insert, '-1');
                $sth->execute();
                $bilder[$i]['filename'] = limitch(basename($filename), 25);
                $dir = new dir_class();
                $dir->setdir($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : ""));
                $bilder[$i]['filesize'] = $dir->fs_convert(basename($filename), 2);
                $bilder[$i]['filetime'] = date("d.m.Y H:i", $dir->last_change(basename($filename)));
                $bilder[$i]['dlink'] = 'view_upload.php?' . SID . '&amp;file=' . basename($filename) . '&amp;loechen=1&amp;kategorie_id=' . $_POST['kategorie'];
                $bilder[$i]['filelink'] = str_replace("/admin", "", $url) . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . basename($filename);
                $i++;

            }
        }
    }
    if ($gd_info['JPG Support'] == true or $gd_info['JPEG Support'] == true) {
        $i = 0;
        foreach (glob($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . "*.[Jj][Pp][Gg]") as $filename) {
            $filename_orginal = basename($filename);
            if ($einstellung['beschreibung_automatisch'] == '1')
                $beschreibung = $upload->get_beschreibung($filename);
            $filename = image_upload::key_url(basename($filename));
            rename($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . $filename_orginal, $root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . $filename);
            $sql_select = "SELECT id FROM `bilder` WHERE dateiname = '" . $dbh->escape(basename($filename)) . "' " . (($_POST['kategorie'] != '') ? "AND `kategorie_id`='" . $dbh->escape($_POST['kategorie']) . "'" : "") . " LIMIT 1;";
            $sth = $dbh->prepare($sql_select, '-1');
            $sth->execute();
            if ($sth->rows() == '0') {
                $sql_insert = "INSERT INTO `bilder` (`id`,`dateiname`,`kategorie_id`,`timestamp`,`admin_id`, `beschreibung`) VALUES(
							'', '" . $dbh->escape(basename($filename)) . "'," . (($_POST['kategorie'] != '') ? "'" . $dbh->escape($_POST['kategorie']) . "'" : "'0'") . ",'" . time() . "','" . $zeileholen['id'] . "', '" . $dbh->escape($beschreibung) . "');";
                $sth = $dbh->prepare($sql_insert, '-1');
                $sth->execute();
                $bilder[$i]['filename'] = limitch(basename($filename), 25);
                $dir = new dir_class();
                $dir->setdir($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : ""));
                $bilder[$i]['filesize'] = $dir->fs_convert(basename($filename), 2);
                $bilder[$i]['filetime'] = date("d.m.Y H:i", $dir->last_change(basename($filename)));
                $bilder[$i]['dlink'] = 'view_upload.php?' . SID . '&amp;file=' . basename($filename) . '&amp;loechen=1&amp;kategorie_id=' . $_POST['kategorie'];
                $bilder[$i]['filelink'] = str_replace("/admin", "", $url) . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . basename($filename);
                $i++;
            }
        }
    }
    if ($gd_info['PNG Support'] == true) {
        $i = 0;
        foreach (glob($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . "*.[Pp][Nn][Gg]") as $filename) {
            $filename_orginal = basename($filename);
            if ($einstellung['beschreibung_automatisch'] == '1')
                $beschreibung = $upload->get_beschreibung($filename);
            $filename = image_upload::key_url(basename($filename));
            rename($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . $filename_orginal, $root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . $filename);
            $sql_select = "SELECT id FROM `bilder` WHERE dateiname = '" . $dbh->escape(basename($filename)) . "' " . (($_POST['kategorie'] != '') ? "AND `kategorie_id`='" . $dbh->escape($_POST['kategorie']) . "'" : "") . " LIMIT 1;";
            $sth = $dbh->prepare($sql_select, '-1');
            $sth->execute();
            if ($sth->rows() == '0') {
                $sql_insert = "INSERT INTO `bilder` (`id`,`dateiname`,`kategorie_id`,`timestamp`,`admin_id`, `beschreibung`) VALUES(
				    		'', '" . $dbh->escape(basename($filename)) . "'," . (($_POST['kategorie'] != '') ? "'" . $dbh->escape($_POST['kategorie']) . "'" : "'0'") . ",'" . time() . "','" . $zeileholen['id'] . "', '" . $dbh->escape($beschreibung) . "');";
                $sth = $dbh->prepare($sql_insert, '-1');
                $sth->execute();
                $bilder[$i]['filename'] = limitch(basename($filename), 25);
                $dir = new dir_class();
                $dir->setdir($root_dir . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : ""));
                $bilder[$i]['filesize'] = $dir->fs_convert(basename($filename), 2);
                $bilder[$i]['filetime'] = date("d.m.Y H:i", $dir->last_change(basename($filename)));
                $bilder[$i]['dlink'] = 'view_upload.php?' . SID . '&amp;file=' . basename($filename) . '&amp;loechen=1&amp;kategorie_id=' . $_POST['kategorie'];
                $bilder[$i]['filelink'] = str_replace("/admin", "", $url) . "/bilder/" . (($daten['kategorie_dir'] != '') ? $daten['kategorie_dir'] . "/" : "") . basename($filename);
                $i++;
            }
        }
    }
    $array['result'] = $bilder;
    header('Content-type: text/html; charset=utf-8');
    if (count($array['result']) == 0) {
        $array['meldung'] = 'Es wurden keine neuen Bilder gefunden.';
    }
    echo(json_encode($array, JSON_FORCE_OBJECT));
    exit;

}
$sql_select = "SELECT id, kategorie_name  FROM `kategorie` ORDER BY `kategorie_name` ASC ;";
$sth = $dbh->prepare($sql_select, '-1');
$sth->execute();
$kategorie = array();
$kategorie[0] = 'Hauptverzeichnis';
if ($sth->rows() != 0) {
    while ($daten = $sth->fetchrow_hash()) {
        $kategorie[$daten['id']] = $daten['kategorie_name'];
    }
}
$upload = new image_upload();
$upload->setpfad($root_dir . '/bilder/');
$upload->setkategorie($kategorie);
$upload->setkategorie_id($_POST['kategorie']);
if ($_POST['beschreibung'] != '') {
    $upload->setbeschreibung($_POST['beschreibung']);
} else {
    if (!empty($_FILES['this_file']['name']) and $einstellung['beschreibung_automatisch'] == '1')
        $upload->setbeschreibung($upload->get_beschreibung($_FILES['this_file']['name']));
}
$upload->set_typforupload($dateiformate);
if ($_POST['send_file'] != '' && $_FILES['this_file'] != '' && !empty($_FILES['this_file']['name'])) {
    $_fileupload = $upload->_fileupload();
    $medlung_fehler = $upload->get_error();
    if ($_fileupload === '1' and $medlung_fehler == '') {
        $meldung = 'Upload erfolgreich!';
    }
    $text["text_upload_admin"] = $upload->_htmlpostfile();
} else {
    if ($upload->check_upload() == true) {
        if ($_POST['send_file'] != '' and empty($_FILES['this_file']['name'])) {
            $medlung_fehler = 'Bitte w&auml;hlen Sie eine Daten aus!';
        }
        $text["text_upload_admin"] = $upload->_htmlpostfile();
    } else {
        $text["text_upload_admin"] = 'Es ist auf diesen Server kein Upload m&ouml;glich, bitte wenden Sie sich an Ihren Hoster und bitten um Aktivierung der Php Upload Funktion.
					<a href="' . htmlspecialchars($_SERVER['PHP_SELF']) . '">Testen</a>' . "\n";
    }
}
$text ["ueberschrift"] = 'Bild hochladen';
$text ["meldung"] = $meldung;
$text ["meldung_fehler"] = $medlung_fehler;
$text ["upload_max_filesize"] = $upload->upload_max_filesize();
$tpl = new parse();
$tpl->set_tpl_pfad($root_dir . "/tpl/admin/");
$tpl->set_file("upload.html");
$tpl->set_script_version($script_version);
$tpl->template($text);
$tpl->template_ausgabe();
?>