<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden.  www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 3.10 - 4.11.2023
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2023
 * @version 	3.10 (PHP8.2)
 * -----------------------------------------
 */

include_once("inc/functions.php");
$url = getUrl();
if (@file_exists('inc/config.php') == true)
include_once("inc/config.php");
else {
    header("Location:" . $url . "/install/");
}
include_once("class/parse.php");
include_once('class/thumbnail_class.php');
include_once('class/directory_list_class.php');
include_once('class/dbcache_class.php');
include_once("class/upload_class.php");
$dbh = new DBI($db_host, $db_datenbank, $db_user, $db_passwort, $root_dir . '/cache/');
$bilder = '';
$ausgabe = '';
$text = array();
$title_zusatz = '';
$dir = new dir_class();
$i = 1;
if (!isset($_GET['kid'])) $_GET['kid'] = '0'; else $_GET['kid'] = sprintf("%d", $_GET['kid']);
$sql_select = "SELECT * FROM `einstellung` ;";
$sth = $dbh->prepare($sql_select, '-1');
$sth->execute();
$bilder_anz = 0;
while ($daten = $sth->fetchrow_hash()) {
    $einstellung[$daten['name']] = $daten['wert'];
}
$upload = new image_upload();
if ($_GET['kid'] == 0) {
    /**
     * Startseite Anzeigen
     */
    $dir->setdir($root_dir . '/bilder/');
    $bilder = $dir->dir_to_array();
    if ($einstellung['hauptverzeichnis_anzeigen'] == 1) {
        $sql_select = "SELECT dateiname, beschreibung, kategorie_id, id FROM `bilder` WHERE `kategorie_id`=0 AND dateiname!='';";
        $sth3 = $dbh->prepare($sql_select, $einstellung['cache_zeit']);
        $sth3->execute();
        $ausgabe .= '<table width="100%">';
        $ausgabe .= '<tr>';
        while ($daten = $sth3->fetchrow_hash()) {
            if (@file_exists($root_dir . '/bilder/' . $daten['dateiname']) == false) {
                $sql_delete = "DELETE FROM `bilder` WHERE `id` = '" . $daten['id'] . "';";
                $sth2 = $dbh->prepare($sql_delete);
                $sth2->execute();
            }
            $dir->thumbnail_delete('/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'], $einstellung['tage_tag_vorschau']);
            if (@file_exists($root_dir . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname']) == false) {
                $thumb = new Thumbnail($root_dir . '/bilder/' . $daten['dateiname']);
                $thumb->resize($einstellung['maxwidth'], $einstellung['maxheight']);
                $thumb->save($root_dir . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'], 200);
            }
            ############################################################################
            /**
             * Resize Original Bild
             */
            if ($einstellung['maxwidth_original'] != 0 and $einstellung['maxheight_original'] != 0) {
                if (@file_exists($root_dir . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname']) == false) {
                    if ($einstellung['resize_to_max'] == 2) {
                        $imagesize = $upload->get_imagesize($root_dir . '/bilder/' . $daten['dateiname']);
                        if ($imagesize != false) {
                            if ($imagesize['width'] > $einstellung['maxwidth_original'] or $imagesize['height'] > $einstellung['maxheight_original']) {
                                $thumb = new Thumbnail($root_dir . '/bilder/' . $daten['dateiname']);
                                $thumb->resize($einstellung['maxwidth_original'], $einstellung['maxheight_original']);
                                $thumb->save($root_dir . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'], 200);
                            }
                        }
                    } else {
                        $thumb = new Thumbnail($root_dir . '/bilder/' . $daten['dateiname']);
                        $thumb->resize($einstellung['maxwidth_original'], $einstellung['maxheight_original']);
                        $thumb->save($root_dir . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'], 200);
                    }
                }
            }
            $beschreibung = (($daten['beschreibung'] != '') ? _htmlspecialchars($daten['beschreibung']) : '');
            $ausgabe .= '<td class="spalten">';
            if ($einstellung['maxwidth_original'] == 0 and $einstellung['maxheight_original'] == 0) {
                $ausgabe .= '<a href="' . $url . '/bilder/' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                $ausgabe .= '</a> ';
            } else {
                if ($einstellung['resize_to_max'] == 2) {
                    $imagesize = $upload->get_imagesize($root_dir . '/bilder/' . $daten['dateiname']);
                    if ($imagesize != false) {
                        if ($imagesize['width'] < $einstellung['maxwidth_original'] or $imagesize['height'] < $einstellung['maxheight_original']) {
                            $ausgabe .= '<a href="' . $url . '/bilder/' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                            $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                            $ausgabe .= '</a>';
                        } else {
                            $ausgabe .= '<a href="' . $url . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                            $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                            $ausgabe .= '</a> ';
                        }
                    }
                } else {
                    $ausgabe .= '<a href="' . $url . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                    $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                    $ausgabe .= '</a> ';
                }
            }
            ############################################################################
            $ausgabe .= '</td>';
            if ($i == $einstellung['umbruch_nach_x_bildern']) {
                $ausgabe .= '</tr><tr>';
                $i = 1;
            } else {
                $i++;
            }
            $bilder_anz++;
        }
        $ausgabe .= '</table>';
        $sth3->finish();
    }
    $sql_select = "SELECT id, kategorie_dir, kategorie_name, kategorie_beschreibung FROM `kategorie`";
    $sth4 = $dbh->prepare($sql_select, $einstellung['cache_zeit']);
    $sth4->execute();
    $kategorie_anzeigen = 1;
    while ($daten = $sth4->fetchrow_hash()) {

        $sql_select2 = "SELECT count(id) as `anz` FROM `bilder` WHERE `kategorie_id`='" . $daten['id'] . "';";
        $sth2 = $dbh->prepare($sql_select2, $einstellung['cache_zeit']);
        $sth2->execute();
        $daten_b = $sth2->fetchrow_hash();
        $sth2->finish();
        if ($daten_b['anz'] <= 0) {
            if ($einstellung['lehre_kategorieen_anzeigen'] == 2) $kategorie_anzeigen = 2;
        }
        if ($kategorie_anzeigen == 1) {
            $ausgabe .= '<p>&nbsp;</p>';
            $ausgabe .= '<p class="ueberschrift_startseite_text"><b>' . _htmlspecialchars($daten['kategorie_name']) . '</b></p>';
            $ausgabe .= '<p class="beschreibung_startseite_text">' . _htmlspecialchars(limitch($daten['kategorie_beschreibung'], $einstellung['textlaenge_beschreibung_startseit'])) . '
		    			<a href="' . _htmlspecialchars($_SERVER['PHP_SELF']) . '?kid=' . $daten['id'] . '">Bilder anzeigen...</a></p>';
            $bilder_anz++;
        }
    }
    $sth4->finish();
} else {
    /**
     * Kategorie Anzeigen
     */
    $sql_select = "SELECT id, kategorie_dir, kategorie_name, kategorie_beschreibung FROM `kategorie` WHERE `id`='" . $dbh->escape($_GET['kid']) . "' LIMIT 1 ;";
    $sth = $dbh->prepare($sql_select, $einstellung['cache_zeit']);
    $sth->execute();
    $daten_kategorie = $sth->fetchrow_hash();
    $sth->finish();
    $sql_select = "SELECT count(id) as `anz` FROM `bilder` WHERE `kategorie_id`='" . $dbh->escape($_GET['kid']) . "';";
    $sth = $dbh->prepare($sql_select, $einstellung['cache_zeit']);
    $sth->execute();
    $daten_b = $sth->fetchrow_hash();
    $sth->finish();
    $title_zusatz = '- ' . _htmlspecialchars($daten_kategorie['kategorie_name']);
    if ($einstellung['kategorieen_name_anzeigen'] == 1)
        $ausgabe .= '<h1>' . _htmlspecialchars($daten_kategorie['kategorie_name']) . '</h1>';
    if ($einstellung['kategorieen_navigation_anzeigen'] == 1)
        $ausgabe .= '<p class="sie_befinden_kategorie_text">Sie befinden sich: <a href="' . _htmlspecialchars($_SERVER['PHP_SELF']) . '"
		    		class="sie_befinden_kategorie_text">Bildergalerie-&Uuml;bersicht</a> &raquo; ' . _htmlspecialchars($daten_kategorie['kategorie_name']) . '</p>';
    if ($einstellung['kategorieen_bilderanzahl_anzeigen'] == 1)
        $ausgabe .= '<p class="anz_kategorie_text">' . (($daten_b['anz'] > 1) ? 'Es sind ' . $daten_b['anz'] . ' Bilder' : 'Es ist ein Bild') . ' in der Kategorie "' . _htmlspecialchars($daten_kategorie['kategorie_name']) . '".</p>';
    if ($einstellung['kategorieen_beschreibung_anzeigen'] == 1) {
        $ausgabe .= '<p class="beschreibung_kategorie_text">' . _htmlspecialchars($daten_kategorie['kategorie_beschreibung']) . '</p>';
        $ausgabe .= '<p>&nbsp;</p>';
    }
    $dir->setdir($root_dir . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/');
    $bilder = $dir->dir_to_array();
    $sql_select = "SELECT dateiname, beschreibung, kategorie_id, id FROM `bilder` WHERE `kategorie_id`='" . $dbh->escape($_GET['kid']) . "';";
    $sth = $dbh->prepare($sql_select, $einstellung['cache_zeit']);
    $sth->execute();
    if ($daten_b['anz'] != 0) {
        $ausgabe .= '<table width="100%">';
        $ausgabe .= '<tr>';
        while ($daten = $sth->fetchrow_hash()) {
            if (@file_exists($root_dir . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname']) == false) {
                $sql_delete = "DELETE FROM `bilder` WHERE `id` = '" . $daten['id'] . "';";
                $sth2 = $dbh->prepare($sql_delete);
                $sth2->execute();
            }
            $dir->thumbnail_delete('/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'], $einstellung['tage_tag_vorschau']);
            if (@file_exists($root_dir . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname']) == false) {
                $thumb = new Thumbnail($root_dir . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname']);
                $thumb->resize($einstellung['maxwidth'], $einstellung['maxheight']);
                $thumb->save($root_dir . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'], 200);
            }
            ############################################################################
            /**
             * Resize Original Bild
             */
            if ($einstellung['maxwidth_original'] != 0 and $einstellung['maxheight_original'] != 0) {
                if (@file_exists($root_dir . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname']) == false) {
                    if ($einstellung['resize_to_max'] == 2) {
                        $imagesize = $upload->get_imagesize($root_dir . '/bilder/' . $daten['dateiname']);
                        if ($imagesize != false) {
                            if ($imagesize['width'] > $einstellung['maxwidth_original'] or $imagesize['height'] > $einstellung['maxheight_original']) {
                                $thumb = new Thumbnail($root_dir . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname']);
                                $thumb->resize($einstellung['maxwidth_original'], $einstellung['maxheight_original']);
                                $thumb->save($root_dir . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'], 200);
                            }
                        }
                    } else {
                        $thumb = new Thumbnail($root_dir . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname']);
                        $thumb->resize($einstellung['maxwidth_original'], $einstellung['maxheight_original']);
                        $thumb->save($root_dir . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'], 200);
                    }
                }
            }


            $beschreibung = (($daten['beschreibung'] != '') ? _htmlspecialchars($daten['beschreibung']) : '');

            $ausgabe .= '<td class="spalten">';
            if ($einstellung['maxwidth_original'] == 0 and $einstellung['maxheight_original'] == 0) {
                $ausgabe .= '<a href="' . $url . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                $ausgabe .= '</a> ';
            } else {
                if ($einstellung['resize_to_max'] == 2) {
                    $imagesize = $upload->get_imagesize($root_dir . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname']);
                    if ($imagesize != false) {
                        if ($imagesize['width'] < $einstellung['maxwidth_original'] or $imagesize['height'] < $einstellung['maxheight_original']) {
                            $ausgabe .= '<a href="' . $url . '/bilder/' . $daten_kategorie['kategorie_dir'] . '/' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                            $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                            $ausgabe .= '</a>';
                        } else {
                            $ausgabe .= '<a href="' . $url . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                            $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                            $ausgabe .= '</a> ';
                        }
                    }
                } else {
                    $ausgabe .= '<a href="' . $url . '/bilder/tn/ob_' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" rel="lightbox[example]" title="' . $beschreibung . '">';
                    $ausgabe .= '<img src="' . $url . '/bilder/tn/tn' . $daten['kategorie_id'] . '_' . $daten['dateiname'] . '" border="0" alt="' . $beschreibung . '" class="vorschau_bild" />';
                    $ausgabe .= '</a> ';
                }
            }

            ############################################################################
            $ausgabe .= '</td>';
            if ($i == $einstellung['umbruch_nach_x_bildern']) {
                $ausgabe .= '</tr><tr>';
                $i = 1;
            } else {
                $i++;
            }
            $bilder_anz++;
        }
        $ausgabe .= '</table>';
    } else {
        $ausgabe .= 'Es ist kein Bild vorhanden.';
    }
}
$sth->finish();
/**
 * Seite ausgeben
 */
if ($bilder_anz == 0) {
    $ausgabe = 'Es sind noch keine Bilder oder Kategorien vorhanden.';
}
$text['ausgabe_bildergalerie'] = $ausgabe;
$text['ausgabe_kategorie'] = $title_zusatz;
$tpl = new parse();
$tpl->set_tpl_pfad($root_dir . '/tpl/');
$tpl->set_file("bildergalerie.html");
$tpl->set_script_version($script_version);
$tpl->template_bildergalerie($text);
$tpl->template_ausgabe();
?>