<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden. ? www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 3.10 - 4.11.2023
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2023
 * @version 	3.10 (PHP8.2)
 * -----------------------------------------
 */
class dir_class {
	private string $dir_folder = '';
	private string $url = '';
    private int $kategorie_id;

    function __construct()
    {
    }

    /**
	 * @param string $dir_folder
	 * @return boolean
	 */
	function setdir(string $dir_folder): bool
    {
		if($dir_folder!='') {
            $this->dir_folder = $dir_folder;
            return true;
        }
        return false;

	}
	/**
	 * @param string $url
	 * @return boolean
	 */
	function seturl(string $url): bool
    {
		if($url!='') {
            $this->url = $url;
            return true;
        }
        return false;
	}
	/**
	 * @param int $kategorie_id
	 * @return boolean
	 */
	function setkategorie_id(int $kategorie_id): bool {
		if($kategorie_id!='') {
            $this->kategorie_id = intval($kategorie_id);
            return true;
        }
        return false;

	}
	/**
	 * @param string $datei
	 * @param int $nachkommastellen
	 * @return string
	 */
	function fs_convert (string $datei, int $nachkommastellen = 0): string {
		$datei=$this->dir_folder.$datei;
		if(@file_exists($datei)){
			$size = @filesize($datei);
			switch ($size) {
	        	case ($size >='1073741824'):
	        		return round($size/(1073741824), $nachkommastellen)." GB";
	        	break;
	        	case ($size >='1048576'):
	        		return round($size/(1048576), $nachkommastellen)." MB";
	        	break;
	        	case ($size >='1024'):
	        		return round($size/(1024), $nachkommastellen)." KB";
	        	break;
	        	default:
	        		return $size." Byte";
	        	break;
	        }
		} else {
			return 'k/a';
		}
	}
	/**
	 * @param string $file
	 * @return boolean
	 */
	function file_delete(string $file): bool{
		global $dbh;
		if($file!=''){
			$this->pfadtofile = $this->dir_folder.$file;
			$this->pfadtotnfile = $this->dir_folder.'/tn/tn'.$this->kategorie_id.'_'.$file;
			$this->filename = $file;
			if($this->kategorie_id!=0){
				$sql_delete="DELETE FROM `bilder` WHERE `dateiname` = '".$dbh->escape($file)."' AND `kategorie_id`='".$dbh->escape($this->kategorie_id)."' LIMIT 1;";
				$sth = $dbh->prepare($sql_delete);
	            $sth->execute();
			}
			if(@file_exists($this->pfadtofile)){
				if(!@unlink($this->pfadtofile)){
					return false;
				} else {
					if(@file_exists($this->pfadtotnfile)){
						if(!@unlink($this->pfadtotnfile)){
							return false;
						} else {
							/**
							 * Thumbnail gel&ouml;scht
							 */
							return true;
						}
					} else {
						/**
						 * Es gibt kein Thumbnail und das Hauptbild w&uuml;rde gel&ouml;scht
						 */
						return true;
					}
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

    /**
     * @param string $file
     * @param int $days
     * @return string|void
     */
    function thumbnail_delete(string $file, int $days=0){
		if($days===0) return '';
		if($this->last_change($file) < (time()-(86400*$days))){
			if(@file_exists($this->dir_folder . $file))
				@unlink($this->dir_folder.$file);
		}
	}
	/**
	 * @param string $file
	 * @return false|int
	 */
	function last_change (string $file): false|int
    {
		return @filemtime($this->dir_folder.$file);
	}
	/**
	 * @return array
	 */
	function dir_to_array(): array
    {
		$ausgabe=array();
		if(!$this->dir_folder){
				$ausgabe[]= 'Keine Verzeichnispfad mit setdir() &uuml;bergeben!';
		} else {
				$i=0;
				//$ausgabe='';
				$dir=@opendir($this->dir_folder);
				if($dir){
					while($file=@readdir($dir)) {
						if ($file != "." && $file != ".."){
							if(!is_dir($this->dir_folder . $file)){
								$ausgabe[]= $file;
								$i++;
							}

						}
					}
					@closedir($dir);
					if($i==0) $ausgabe[]= 'Keine Datei vorhanden!';
				} else {
					$ausgabe[]= 'Kann den Verzeichnispfad '.$this->dir_folder.' nicht &ouml;ffnen!';
				}
			}
			return $ausgabe;
	}
	/**
	 * @return string
	 */
	function view_dir(): string
    {
		$ausgabe='';
		if(!$this->dir_folder){
			$ausgabe.= 'Keine Verzeichnispfad mit setdir() &uuml;bergeben!';
		} else {
			if(!$this->url){
				$ausgabe.= 'Keine Url mit seturl() &uuml;bergeben!';
			} else {
				$i=0;
				$dir=@opendir($this->dir_folder);
				if($dir){
					$key=$this->getkey();
					$ausgabe.='<div class="tab"><table border="0" cellspacing="2" cellpadding="2" width="100%" id="'.$key.'" class="filelist">'."\n";
					$ausgabe.='	<tr class="filelist_tr" style="font-weight:bold;">'."\n";
					$ausgabe.='		<td class="view_dir_td_315 fett">Datei</td>'."\n";
					$ausgabe.='		<td class="view_dir_td_70 fett" nowrap="nowrap">Gr&ouml;&szlig;e</td>'."\n";
					$ausgabe.='		<td nowrap="nowrap" class="view_dir_td_90 fett">Letzte &Auml;nderung</td>'."\n";
					$ausgabe.='		<td nowrap="nowrap" class="view_dir_td_70 fett">Aktion</td>'."\n";
					$ausgabe.='	</tr>'."\n";
					while($file=@readdir($dir)) {
						if ($file != "." && $file != ".."){
							if(!is_dir($this->dir_folder . $file)){
								if($this->check_bild($file)){
									$ausgabe.='<tr class="filelist_tr">'."\n";
									$ausgabe.='	<td nowrap="nowrap"><a href="'.htmlspecialchars($this->url.$file).'"  target="_blank">'.limitch($file,35).'</a></td>'."\n";
									$ausgabe.='	<td nowrap="nowrap">'.$this->fs_convert($file,2).'</td>'."\n";
									$ausgabe.='	<td nowrap="nowrap">'.date("d.m.Y H:i", $this->last_change($file)).'</td>'."\n";
									$ausgabe.='	<td nowrap="nowrap"><a href="javascript:frage_to_url(\'M&ouml;chten Sie diese Datei wirklich l&ouml;schen?\',\'view_upload.php?'.SID.'&amp;file='.
									htmlspecialchars($file).'&amp;loechen=1&amp;kategorie_id='.htmlspecialchars($this->kategorie_id).'\');" >L&ouml;schen</a></td>'."\n";
									$ausgabe.='</tr>'."\n";
									$i++;
								}
							}
						}
					}
					@closedir($dir);
					if($i==0) {
						$ausgabe.='<tr bgcolor="Gainsboro">'."\n";
						$ausgabe.='	<td colspan="4">Keine Datei vorhanden!</td>'."\n";
						$ausgabe.='</tr>'."\n";
					}
					$ausgabe.='</table></div>+ <a href="upload.php?'.SID.'&amp;kategorie='.htmlspecialchars($this->kategorie_id).'">Bilde hochladen</a> &#10059;
							<a href="javascript:synchronisieren(\''.htmlspecialchars($this->kategorie_id).'\',\''.$key.'\');">FTP-Verzeichnis synchronisieren</a><br /><br />'."\n";
				} else {
					$ausgabe.= 'Kann den Verzeichnispfad '.$this->dir_folder.' nicht &ouml;ffnen!';
				}
			}
		}
		return $ausgabe;
	}
	/**
	 * @param string $dateiname
	 * @return boolean
	 */
	function check_bild(string $dateiname): bool
    {
		global $dbh;
		$sql_select='SELECT dateiname  FROM `bilder` WHERE `dateiname` = \''.$dbh->escape($dateiname).'\' AND `kategorie_id` =\''.$dbh->escape($this->kategorie_id).'\' LIMIT 1;';
		$sth = $dbh->prepare($sql_select, '-1');
		$sth->execute();
		if($sth->rows()!='0'){
			return true;
		} else {
			return false;
		}
	}
	/**
	 * @return boolean
	 */
	function clear_db(): bool
    {
		global $dbh,$root_dir;
		/**
		* Select von bilder mit Left Join von kategorie
		*/
		$sql_select='SELECT
					`a`.`dateiname`,
					`a`.`id` AS `bild_id`,
					`b`.`kategorie_dir`
						FROM `bilder` AS `a`
					LEFT JOIN
						`kategorie` AS `b`
					ON `a`.`kategorie_id` = `b`.`id`;';
		$sth = $dbh->prepare($sql_select, '-1');
		$sth->execute();
		if($sth->rows()!='0'){
			while($daten = $sth->fetchrow_hash()){
				if(!@file_exists($root_dir . '/bilder/' . (($daten['kategorie_dir'] != NULL) ? $daten['kategorie_dir'] . '/' : '') . $daten['dateiname'])){
					$sql_delete="DELETE FROM `bilder` WHERE `id` = '".$daten['bild_id']."';";
					$sth2 = $dbh->prepare($sql_delete, '-1');
					$sth2->execute();
				}

			}
		}
		return true;
	}
	/**
	 * @return string
	 */
	function getkey(): string
    {
		$newkey = "";
		$laenge=10;
		$string="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

		mt_srand((double)microtime()*1000000);

		for ($i=1; $i <= $laenge; $i++) {
			$newkey .= substr($string, mt_rand(0,strlen($string)-1), 1);
		}
		return $newkey;
	}
}