<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden.  www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 3.10 - 4.11.2023
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2023
 * @version 	3.10 (PHP8.2)
 * -----------------------------------------
 */
class parse {
	/**
	 * @var string
	 * @access private
	 */
	private $ausgabe;
	/**
	 * @var string
	 * @access private
	 */
	private $tpl_pfad='';
	/**
	 * @var string
	 * @access private
	 */
	private $parse_file='';
	/**
	 * @var string
	 * @access private
	 */
	private $script_version='0';
	/**
	 * @var array
	 * @access public
	 */
	public $lang=array();
	/**
	 * @param string $script_version
	 */
	function set_script_version($script_version){
		if($script_version!='0')
			$this->script_version=$script_version;
		else {
			echo 'Ung&uuml;ltiger Aufruf! Bitte set_script_version() definieren bei beim Objekt von der Klasse "parse".';
			exit;
		}
	}
	/**
	 * @param string $tpl_pfad
	 */
	function set_tpl_pfad ($tpl_pfad) {
		if($tpl_pfad==''){
			echo 'Bitte geben Sie den Pfad zum "tpl" Ordner an!';
			exit;
		} else {
			if(@file_exists($tpl_pfad)==true){
				$this->tpl_pfad=$tpl_pfad;
			} else {
				echo 'Den Tpl Ordner: "'.$tpl_pfad.'" gibt es nicht aus den Server.';
				exit;
			}
		}
	}
	/**
	 * @param string $parse_file
	 */
	function set_file ($parse_file) {
		if($parse_file==''){
			echo 'Ung&uuml;ltiger Aufruf!';
			exit;
		} else {
			if(@file_exists($this->tpl_pfad.$parse_file)==true){
				$this->parse_file=$parse_file;
			} else {
				echo 'Die Tpl Datei: "'.$parse_file.'" gibt es nicht im Ordner: "'.$this->tpl_pfad.'".';
				exit;
			}
		}
	}
	/**
	 * @param array $lang
	 * @return boolean
	 */
	function template ($lang=array()) {
		if(count($lang)==0){
			echo 'Ung&uuml;ltiger Aufruf! Bei template() wurde kein Array &uuml;bergeben.';
			exit;
		}
		if($this->script_version=='0'){
			echo 'Ung&uuml;ltiger Aufruf! Vor template() muss mit set_script_version() das Objekt definiert werden bei der Klasse "parse".';
			exit;
		}
		$fp = @fopen($this->tpl_pfad.'/navigation.html', "r");
		$navigation = @fread($fp, filesize($this->tpl_pfad.'/navigation.html'));
		$navigation = str_replace('{SID}', '?'.SID, $navigation);
		$fp = @fopen($this->tpl_pfad.$this->parse_file, "r");
		$to_parse = @fread($fp, filesize($this->tpl_pfad.$this->parse_file));
		$pattern="#({IF [^}]*})(.+){/IF[^}]*}#isU";
		$pattern2="#{IF (.+)}#is";
		preg_match_all($pattern, $to_parse, $parse_vars);
		$stop = count($parse_vars[0]);
		for($x=0;$x<$stop;$x++){
			preg_match_all($pattern2, strtolower($parse_vars[1][$x]), $parse_vars2);
			if(!empty($lang[$parse_vars2[1][0]])){
				$to_parse = str_replace($parse_vars[0][$x], $parse_vars[2][$x], $to_parse);
			} else {
				$to_parse = str_replace($parse_vars[0][$x], '', $to_parse);
			}
		}
		$to_parse = str_replace('{NAVIGATION}', $navigation, $to_parse);
		$to_parse = str_replace('{SCRIPT_VERSION}', $this->script_version, $to_parse);
		preg_match_all("/{([0-9A-Z_]*)}/", $to_parse, $parse_vars);
		$stop = count($parse_vars[0]);
		for($x=0;$x<$stop;$x++){
			$lang_ident = strtolower($parse_vars[1][$x]);
			if(!isset($lang[$lang_ident])) $lang[$lang_ident]='';
			$to_parse = str_replace($parse_vars[0][$x], $lang[$lang_ident], $to_parse);

		}
		$this-> ausgabe = $to_parse;
		return true;
	}
	/**
	 * @param array $lang
	 * @return boolean
	 */
	function template_bildergalerie ($lang) {
		if(count($lang)==0){
			echo 'Ung&uuml;ltiger Aufruf! Bei template_bildergalerie() wurde kein Array &uuml;bergeben.';
			exit;
		}
		if($this->script_version=='0'){
			echo 'Ung&uuml;ltiger Aufruf! Vor template() muss mit set_script_version() das Objekt definiert werden bei der Klasse "parse".';
			exit;
		}
		$fp = @fopen($this->tpl_pfad.$this->parse_file, "r");
		$to_parse = fread($fp, filesize($this->tpl_pfad.$this->parse_file));
		$to_parse = str_replace('{SCRIPT_VERSION}', $this->script_version, $to_parse);
		preg_match_all("/{([0-9A-Z_]*)}/", $to_parse, $parse_vars);
		$stop = count($parse_vars[0]);
		for($x=0;$x<$stop;$x++){
			$lang_ident = strtolower($parse_vars[1][$x]);
			if(!isset($lang[$lang_ident])) $lang[$lang_ident]='';
			$to_parse = str_replace($parse_vars[0][$x], $lang[$lang_ident], $to_parse);
		}
		$this-> ausgabe = $to_parse;
		return true;
	}
	/**
	 * @return boolean
	 */
	function template_ausgabe() {
		eval (base64_decode(
			'aWYoaGVhZGVyc19zZW50KCk9PWZhbHNlKXsNCgkJCWhlYWRlcignQ29udGVudC1UeXBlOiB0ZXh0' .
			'L2h0bWw7IGNoYXJzZXQ9dXRmLTgnLCB0cnVlKTsNCgkJfQ0KCQlpZihwcmVnX21hdGNoKCcvPFwv' .
			'Ym9keT4vJywkdGhpcy0+YXVzZ2FiZSk9PTApIGVjaG8gJHRoaXMtPmF1c2dhYmUuJzxjZW50ZXI+' .
			'Q29weXJpZ2h0IGJ5IDxhIGhyZWY9Imh0dHA6Ly93d3cuYmlsZGVyZ2FsZXJpZS1zY3JpcHQuZGUv' .
			'IiB0YXJnZXQ9Il9ibGFuayI+QmlsZGVyZ2FsZXJpZS1TY3JpcHQuZGU8L2E+PC9jZW50ZXI+JzsN' .
			'CgkJZWxzZSBlY2hvIHN0cl9yZXBsYWNlKCc8L2JvZHk+JywgJzxjZW50ZXI+Q29weXJpZ2h0IGJ5' .
			'IDxhIGhyZWY9Imh0dHA6Ly93d3cuYmlsZGVyZ2FsZXJpZS1zY3JpcHQuZGUvIiB0YXJnZXQ9Il9i' .
			'bGFuayI+QmlsZGVyZ2FsZXJpZS1TY3JpcHQuZGU8L2E+PC9jZW50ZXI+PC9ib2R5PicsJHRoaXMt' .
			'PmF1c2dhYmUpOw=='));
	}
}
?>